/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Indexes;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreLogiccond.TCoreLogiccondPath;
import de.ship.db.tables.TCoreLogicorgrp.TCoreLogicorgrpPath;
import de.ship.db.tables.records.TCoreLogicandgrpRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Index;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreLogicandgrp extends TableImpl<TCoreLogicandgrpRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_logicandgrp</code>
     */
    public static final TCoreLogicandgrp T_CORE_LOGICANDGRP = new TCoreLogicandgrp();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreLogicandgrpRecord> getRecordType() {
        return TCoreLogicandgrpRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_logicandgrp.lastchange</code>.
     */
    public final TableField<TCoreLogicandgrpRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_logicandgrp.andgrp</code>. id of
     * logical and group
     */
    public final TableField<TCoreLogicandgrpRecord, Integer> ANDGRP = createField(DSL.name("andgrp"), SQLDataType.INTEGER.nullable(false), this, "id of logical and group");

    /**
     * The column <code>common_dd.t_core_logicandgrp.fk_orgrp</code>. reference
     * to or group
     */
    public final TableField<TCoreLogicandgrpRecord, Integer> FK_ORGRP = createField(DSL.name("fk_orgrp"), SQLDataType.INTEGER.nullable(false), this, "reference to or group");

    private TCoreLogicandgrp(Name alias, Table<TCoreLogicandgrpRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreLogicandgrp(Name alias, Table<TCoreLogicandgrpRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_logicandgrp</code> table
     * reference
     */
    public TCoreLogicandgrp(String alias) {
        this(DSL.name(alias), T_CORE_LOGICANDGRP);
    }

    /**
     * Create an aliased <code>common_dd.t_core_logicandgrp</code> table
     * reference
     */
    public TCoreLogicandgrp(Name alias) {
        this(alias, T_CORE_LOGICANDGRP);
    }

    /**
     * Create a <code>common_dd.t_core_logicandgrp</code> table reference
     */
    public TCoreLogicandgrp() {
        this(DSL.name("t_core_logicandgrp"), null);
    }

    public <O extends Record> TCoreLogicandgrp(Table<O> path, ForeignKey<O, TCoreLogicandgrpRecord> childPath, InverseForeignKey<O, TCoreLogicandgrpRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_LOGICANDGRP);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreLogicandgrpPath extends TCoreLogicandgrp implements Path<TCoreLogicandgrpRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreLogicandgrpPath(Table<O> path, ForeignKey<O, TCoreLogicandgrpRecord> childPath, InverseForeignKey<O, TCoreLogicandgrpRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreLogicandgrpPath(Name alias, Table<TCoreLogicandgrpRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreLogicandgrpPath as(String alias) {
            return new TCoreLogicandgrpPath(DSL.name(alias), this);
        }

        @Override
        public TCoreLogicandgrpPath as(Name alias) {
            return new TCoreLogicandgrpPath(alias, this);
        }

        @Override
        public TCoreLogicandgrpPath as(Table<?> alias) {
            return new TCoreLogicandgrpPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public List<Index> getIndexes() {
        return Arrays.asList(Indexes.IDX_CORE_LOGICANDGRP_FK_ORGRP);
    }

    @Override
    public UniqueKey<TCoreLogicandgrpRecord> getPrimaryKey() {
        return Keys.PK_CORE_LOGICANDGRP;
    }

    @Override
    public List<ForeignKey<TCoreLogicandgrpRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_LOGICANDGRP__FK_AND_ORGRP);
    }

    private transient TCoreLogicorgrpPath _tCoreLogicorgrp;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_logicorgrp</code> table.
     */
    public TCoreLogicorgrpPath tCoreLogicorgrp() {
        if (_tCoreLogicorgrp == null)
            _tCoreLogicorgrp = new TCoreLogicorgrpPath(this, Keys.T_CORE_LOGICANDGRP__FK_AND_ORGRP, null);

        return _tCoreLogicorgrp;
    }

    private transient TCoreLogiccondPath _tCoreLogiccond;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_logiccond</code> table
     */
    public TCoreLogiccondPath tCoreLogiccond() {
        if (_tCoreLogiccond == null)
            _tCoreLogiccond = new TCoreLogiccondPath(this, null, Keys.T_CORE_LOGICCOND__FK_COND_ANDGRP.getInverseKey());

        return _tCoreLogiccond;
    }

    @Override
    public TCoreLogicandgrp as(String alias) {
        return new TCoreLogicandgrp(DSL.name(alias), this);
    }

    @Override
    public TCoreLogicandgrp as(Name alias) {
        return new TCoreLogicandgrp(alias, this);
    }

    @Override
    public TCoreLogicandgrp as(Table<?> alias) {
        return new TCoreLogicandgrp(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLogicandgrp rename(String name) {
        return new TCoreLogicandgrp(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLogicandgrp rename(Name name) {
        return new TCoreLogicandgrp(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLogicandgrp rename(Table<?> name) {
        return new TCoreLogicandgrp(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogicandgrp where(Condition condition) {
        return new TCoreLogicandgrp(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogicandgrp where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogicandgrp where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogicandgrp where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogicandgrp where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogicandgrp where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogicandgrp where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogicandgrp where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogicandgrp whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogicandgrp whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
